blob: a8f02cf2300f65e2b769d7fad2dfbb640d96461a [file] [log] [blame]
Sean Condona36f65c2019-05-20 08:21:41 +01001"""
2 Copyright ${year}-present Open Networking Foundation
3
4 Licensed under the Apache License, Version 2.0 (the "License");
5 you may not use this file except in compliance with the License.
6 You may obtain a copy of the License at
7
8 http://www.apache.org/licenses/LICENSE-2.0
9
10 Unless required by applicable law or agreed to in writing, software
11 distributed under the License is distributed on an "AS IS" BASIS,
12 WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
13 See the License for the specific language governing permissions and
14 limitations under the License.
15"""
16
17"""
18 Rules to build the ${artifactId} for GUI 2
19
20
21"""
22
23COMPILE_DEPS = CORE_DEPS + JACKSON + KRYO + [
24 "@javax_ws_rs_api//jar",
25 "@servlet_api//jar",
26 "@jetty_websocket//jar",
27 "@jetty_util//jar",
28 "@jersey_media_multipart//jar",
29 "@jersey_server//jar",
30 "//utils/rest:onlab-rest",
31 "//core/store/serializers:onos-core-serializers",
32]
33
34TEST_DEPS = TEST + [
35 "//core/api:onos-api-tests",
36 "//drivers/default:onos-drivers-default",
37]
38
39"""
40 Files that get put at the top level of the tar ball
41"""
42
43filegroup(
44 name = "_root_level_files",
45 srcs =
46 [
47 ":angular.json",
48 ":package.json",
49 ":package-lock.json",
50 ":tsconfig.json",
51 ":tslint.json",
52 ],
53)
54
55filegroup(
56 name = "_e2e_test_files",
57 srcs = [
58 ":e2e/protractor.conf.js",
59 ":e2e/src/app.e2e-spec.ts",
60 ":e2e/src/app.po.ts",
61 ":e2e/tsconfig.e2e.json",
62 ],
63)
64
65"""
66 Run ng build to create ${artifactId} GUI 2 library in production mode
67 The output file ${artifactId}-gui-lib-ver.tgz is in the form that can be uploaded directly to https://www.npmjs.com/
68 See bazel-genfiles/web/${artifactId}-gui-lib/${artifactId}-gui-lib.log for details of the Angular CLI output
69"""
70
71genrule(
72 name = "${artifactId}-gui-lib-build",
73 srcs = [
74 "@nodejs//:bin/npm",
75 "@nodejs//:bin/node",
76 "@nodejs//:bin/nodejs/bin/node",
77 "@nodejs//:bin/nodejs/bin/npm",
78 "//web/gui2-fw-lib:onos-gui2-fw-npm-install",
79 "//web/gui2-fw-lib:onos-gui2-fw-ng-build",
80 "//web/gui2-fw-lib:gui2_fw_lib_ext_css",
81 ":_root_level_files",
82 ":_${artifactId}_lib_src",
83 ":_${artifactId}_tester_files",
84 ],
85 outs = [
86 "${artifactId}-gui-lib.log",
87 "${artifactId}-gui-lib-ver.tgz",
88 ],
89 cmd = "ROOT=`pwd` &&" +
90 " export HOME=. &&" +
91 " export XDG_CONFIG_HOME=$(@D)/config &&" +
92 " NODE=$(location @nodejs//:bin/node) &&" +
93 " INSTALL_FILES=($(locations //web/gui2-fw-lib:onos-gui2-fw-npm-install)) &&" + # An array of filenames - sorted by time created
94 " ${appNameAllCaps}_FILES=($(locations //web/gui2-fw-lib:onos-gui2-fw-ng-build)) &&" + # An array of filenames - sorted by time created
95 " mkdir -p web/${artifactId}-gui-lib &&" +
96 " cd web/${artifactId}-gui-lib &&" +
97 " jar xf $$ROOT/$${INSTALL_FILES[0]} &&" +
98 " tar xf $$ROOT/$${${appNameAllCaps}_FILES[0]} &&" +
99 " mv package/ node_modules/gui2-fw-lib/ &&" +
100 " mkdir -p projects/${artifactId}-gui-lib/fw &&" +
101 " (cd projects/${artifactId}-gui-lib/fw &&" +
102 " jar xf $$ROOT/$(location //web/gui2-fw-lib:gui2_fw_lib_ext_css)) &&" +
103 " chmod +x node_modules/@angular/cli/bin/ng &&" +
104 " export PATH=$$ROOT/$$(dirname $${NODE}):$$ROOT/web/${artifactId}-gui-lib/node_modules/@angular/cli/bin:$$PATH &&" +
105 " ng build ${artifactId}-gui-lib >> $$ROOT/$(location ${artifactId}-gui-lib.log) 2>&1 ||" +
106 " if [ $$? -eq 0 ]; then echo 'Successfully ran build';" +
107 " else " +
108 " echo 'Error running \'ng build ${artifactId}-gui-lib\' on \'//web/${artifactId}-gui-lib:${artifactId}-gui-lib-build\'. \\\n" +
109 " See bazel-genfiles/web/${artifactId}-gui-lib/${artifactId}-gui-lib.log for more details' >&2;" +
110 #" tail -n 100 ../../$(location onos-gui2-ng-test.log) >&2;" +
111 " exit 1;" +
112 " fi;" +
113 " cd dist/${artifactId}-gui-lib && " +
114 " npm pack >> $$ROOT/$(location ${artifactId}-gui-lib.log) 2>&1 &&" +
115 " mv ${artifactId}-gui-lib-*.tgz $$ROOT/$(location ${artifactId}-gui-lib-ver.tgz) &&" +
116 " touch $$ROOT/$(location ${artifactId}-gui-lib.log)", # to get the log always as the 2nd file,
117 message = "Angular Topo GUI2 build",
118 visibility = ["//visibility:public"],
119)
120
121"""
122 Run 'ng test' to run Angular test and 'ng lint' for checkstyle
123 See bazel-genfiles/web/${artifactId}-gui-lib/${artifactId}-gui-lib-lint.log or
124 bazel-genfiles/web/${artifactId}-gui-lib/${artifactId}-gui-lib-test.log for details of the Angular CLI output
125"""
126
127genrule(
128 name = "_${artifactId}-gui-lib-test-genrule",
129 srcs = [
130 "@nodejs//:bin/npm",
131 "@nodejs//:bin/node",
132 "@nodejs//:bin/nodejs/bin/node",
133 "@nodejs//:bin/nodejs/bin/npm",
134 "//web/gui2-fw-lib:onos-gui2-fw-npm-install",
135 "//web/gui2-fw-lib:onos-gui2-fw-ng-build",
136 "//web/gui2-fw-lib:gui2_fw_lib_ext_css",
137 ":_root_level_files",
138 ":_${artifactId}_lib_src",
139 ":_${artifactId}_lib_src_tests",
140 ],
141 outs = [
142 "${artifactId}-gui-lib-ver.log",
143 "${artifactId}-gui-lib-lint.log",
144 "${artifactId}-gui-lib-test.log",
145 ],
146 cmd = " ROOT=`pwd` &&" +
147 " export HOME=. &&" +
148 " export XDG_CONFIG_HOME=$(@D)/config &&" +
149 " NODE=$(location @nodejs//:bin/node) &&" +
150 " INSTALL_FILES=($(locations //web/gui2-fw-lib:onos-gui2-fw-npm-install)) &&" + # An array of filenames - sorted by time created
151 " FWLIB_FILES=($(locations //web/gui2-fw-lib:onos-gui2-fw-ng-build)) &&" + # An array of filenames - sorted by time created
152 " mkdir -p web/${artifactId}-gui-lib &&" +
153 " cd web/${artifactId}-gui-lib &&" +
154 " jar xf ../../$(location :_${artifactId}_lib_src_tests) &&" +
155 " jar xf $$ROOT/$${INSTALL_FILES[0]} &&" +
156 " tar xf $$ROOT/$${FWLIB_FILES[0]} &&" +
157 " mv package/ node_modules/gui2-fw-lib/ &&" +
158 " mkdir -p projects/${artifactId}-gui-lib/fw &&" +
159 " (cd projects/${artifactId}-gui-lib/fw &&" +
160 " jar xf $$ROOT/$(location //web/gui2-fw-lib:gui2_fw_lib_ext_css)) &&" +
161 " chmod +x $$ROOT/web/${artifactId}-gui-lib/node_modules/@angular/cli/bin/ng &&" +
162 " export PATH=$$ROOT/$$(dirname $${NODE}):node_modules/@angular/cli/bin:$$PATH &&" +
163 " node -v > ../../$(location ${artifactId}-gui-lib-ver.log) &&" +
164 " npm -v >> ../../$(location ${artifactId}-gui-lib-ver.log) &&" +
165 " ng version >> ../../$(location ${artifactId}-gui-lib-ver.log) &&" +
166 " ng lint ${artifactId}-gui-lib > ../../$(location ${artifactId}-gui-lib-lint.log) 2>&1 ||" +
167 " if [ $$? -eq 0 ]; then echo 'Successfully ran lint';" +
168 " else " +
169 " echo 'Error running \'ng lint\' on \'//web/${artifactId}-gui-lib:_${artifactId}-gui-lib-test-genrule\'. \\\n" +
170 " See bazel-genfiles/web/${artifactId}-gui-lib/${artifactId}-gui-lib-lint.log for more details' >&2;" +
171 " exit 1;" +
172 " fi;" +
173 " if [ -f /usr/bin/chromium-browser ]; then " + # Add to this for Mac and Chrome
174 " export CHROME_BIN=/usr/bin/chromium-browser; " +
175 " elif [ -f /opt/google/chrome/chrome ]; then " +
176 " export CHROME_BIN=/opt/google/chrome/chrome; " +
177 " else " +
178 " MSG='Warning: Step ${artifactId}-gui-lib-tests skipped because \\n" +
179 " no binary for ChromeHeadless browser was found at /usr/bin/chromium-browser. \\n" +
180 " Install Google Chrome or Chromium Browser to allow this step to run.';" +
181 " echo -e $$MSG >&2;" +
182 " echo -e $$MSG > ../../$(location ${artifactId}-gui-lib-test.log);" +
183 " exit 0;" +
184 " fi;" +
185 " ng test ${artifactId}-gui-lib --preserve-symlinks --code-coverage --browsers=ChromeHeadless" +
186 " --watch=false > ../../$(location ${artifactId}-gui-lib-test.log) 2>&1 ||" +
187 " if [ $$? -eq 0 ]; then echo 'Successfully ran tests';" +
188 " else " +
189 " echo 'Error running \'ng test ${artifactId}-gui-lib\' on \'//web/${artifactId}-gui-lib:_${artifactId}-gui-lib-test-genrule\'. \\\n" +
190 " See bazel-genfiles/web/${artifactId}-gui-lib/${artifactId}-gui-lib-test.log for more details' >&2;" +
191 " exit 1;" +
192 " fi;",
193 message = "Angular Topo GUI2 Lib lint and test",
194)
195
196"""
197 Make a group of all the webapp files.
198"""
199
200filegroup(
201 name = "_${artifactId}_lib_src",
202 srcs = glob(
203 [
204 "projects/${artifactId}-gui-lib/**/*",
205 ],
206 exclude = [
207 "projects/${artifactId}-gui-lib/**/*.spec.*", # Don't track tests here
208 "projects/${artifactId}-gui-lib/karma.conf.js",
209 "projects/${artifactId}-gui-lib/src/test.ts",
210 "projects/${artifactId}-gui-lib/fw/**/*",
211 ],
212 ),
213)
214
215"""
216 Make a group of all the webapp qpp files.
217"""
218
219filegroup(
220 name = "_${artifactId}_tester_files",
221 srcs = glob(
222 [
223 "src/**/*",
224 ],
225 ),
226)
227
228"""
229 Make a jar file of all the webapp test (*.spec.ts) files.
230"""
231
232genrule(
233 name = "_${artifactId}_lib_src_tests",
234 srcs = glob(
235 [
236 "projects/${artifactId}-gui-lib/karma.conf.js",
237 "projects/${artifactId}-gui-lib/src/test.ts",
238 "projects/${artifactId}-gui-lib/tsconfig.spec.json",
239 "projects/${artifactId}-gui-lib/**/*.spec.ts",
240 ],
241 exclude = [
242 "projects/${artifactId}-gui-lib/ng-package.json",
243 "projects/${artifactId}-gui-lib/ng-package.prod.json",
244 "projects/${artifactId}-gui-lib/package.json",
245 "projects/${artifactId}-gui-lib/tsconfig.lib.json",
246 "projects/${artifactId}-gui-lib/tslint.json",
247 "projects/${artifactId}-gui-lib/src/public_api.ts",
248 ],
249 ),
250 outs = ["${artifactId}_gui_lib_src_tests.jar"],
251 cmd = "cd web/${artifactId}-gui-lib &&" +
252 " jar Mcf ../../$@ .",
253)
254
255"""
256 Make a jar file of all the webapp test (*.spec.ts) files.
257"""
258
259genrule(
260 name = "_${artifactId}_gui_lib_tests",
261 srcs = glob(
262 [
263 "projects/${artifactId}-gui-lib/**/*.spec.ts",
264 "projects/${artifactId}-gui-lib/**/*.spec.json",
265 ],
266 exclude = [
267 "src/main/webapp/tests/**",
268 "src/main/webapp/node_modules/**",
269 "src/main/webapp/dist/**",
270 "src/main/webapp/doc/**",
271 ],
272 ),
273 outs = ["${artifactId}_gui_lib_tests.jar"],
274 cmd = "cd web/${artifactId}-gui-lib &&" +
275 " find projects/${artifactId}-gui-lib/src/lib -type f -exec touch -t 201808280000 {} \; &&" +
276 " jar Mcf ../../$@ projects/${artifactId}-gui-lib/src/lib",
277)
278
279"""
280 Wrap the genrule for testing in a test
281"""
282
283sh_test(
284 name = "${artifactId}-gui-lib-tests",
285 size = "small",
286 srcs = [
287 ":ng-test.sh",
288 ],
289 data = [
290 ":_${artifactId}-gui-lib-test-genrule",
291 ],
292 deps = [
293 "@bazel_tools//tools/bash/runfiles",
294 ],
295)